import sys
import os
import numpy as np
import matplotlib.pyplot as plt

XSphRadfiles = ["XSphRad_O3a.csv"        ,"XSphRad_O3b.csv"]
stamp1  = ["stamp_lonetrack_O3a.csv","stamp_lonetrack_O3b.csv"]
stamp2  = ["stamp_zebragard_O3a.csv","stamp_zebragard_O3b.csv"]
cWBfile = 'cWB_eff50.txt'

XSphRadO3a ={
      "name": np.loadtxt(XSphRadfiles[0],skiprows=2,usecols=[0],delimiter=";",unpack=True,dtype=str)
    , "val" : np.loadtxt(XSphRadfiles[0],skiprows=2,usecols=[1],delimiter=";",unpack=True)
    }
lonetrackO3a ={
      "name": np.loadtxt(stamp1[0],usecols=[0],delimiter=",",unpack=True,dtype=str)
    , "val" : np.loadtxt(stamp1[0],usecols=[4],delimiter=",",unpack=True)          
    }
zebragardO3a ={
      "name": np.loadtxt(stamp2[0],usecols=[0],delimiter=",",unpack=True,dtype=str)
    , "val" : np.loadtxt(stamp2[0],usecols=[4],delimiter=",",unpack=True)          
    }
cWBO3a = {
      "name": np.loadtxt('cWB_eff50.txt',usecols=[5],unpack=True,delimiter=",",dtype=str)
    , "val" : np.loadtxt('cWB_eff50.txt',usecols=[4],unpack=True,delimiter=",")
    , "nameCWB": np.array([ncWB.strip()
          for ncWB in np.loadtxt('cWB_eff50.txt',usecols=[0],unpack=True,delimiter=",",dtype=str)
    ])
}
XSphRadO3b ={
      "name": np.loadtxt(XSphRadfiles[1],skiprows=2,usecols=[0],delimiter=";",unpack=True,dtype=str)
    , "val" : np.loadtxt(XSphRadfiles[1],skiprows=2,usecols=[1],delimiter=";",unpack=True)
    }
lonetrackO3b ={
      "name": np.loadtxt(stamp1[1],usecols=[0],delimiter=",",unpack=True,dtype=str)
    , "val" : np.loadtxt(stamp1[1],usecols=[4],delimiter=",",unpack=True)          
    }
zebragardO3b ={
      "name": np.loadtxt(stamp2[1],usecols=[0],delimiter=",",unpack=True,dtype=str)
    , "val" : np.loadtxt(stamp2[1],usecols=[4],delimiter=",",unpack=True)          
    }
cWBO3b = {
      "name": np.loadtxt('cWB_eff50.txt',usecols=[5],unpack=True,delimiter=",",dtype=str)
    , "val" : np.loadtxt('cWB_eff50.txt',usecols=[3],unpack=True,delimiter=",")
    , "nameCWB": np.array([ncWB.strip()
          for ncWB in np.loadtxt('cWB_eff50.txt',usecols=[0],unpack=True,delimiter=",",dtype=str)
    ])
}


names_XSphRad=[
        'ncsacam_d', 'ncsacam_e', 'ncsacam_a', 'ncsacam_b', 'ncsacam_f',
        'ncsacam_c', 'grbplateaushort', 'adi_b', 'iscochirp_c',
        'maxgnetar_f', 'msmagnetar_a', 'iscochirp_b', 'iscochirp_a',
        'maxgnetar_e', 'maxgnetar_d']
idname_XSphRad=[
        'NCSA-CAM D', 'NCSA-CAM E', 'NCSA-CAM A', 'NCSA-CAM B', 'NCSA-CAM F',
        'NCSA-CAM C', 'GRB plateau Short', 'ADI B', 'ISCO chirp C',
        'Magnetar F', 'MS Magnetar A', 'ISCO chirp B', 'ISCO chirp A',
        'Magnetar E', 'Magnetar D']
waveforms=zebragardO3a['name']
dict_XSphRad = { wf : "" for wf in waveforms}
for i in range(len(names_XSphRad)):
    dict_XSphRad[idname_XSphRad[i]]= names_XSphRad[i]


DATA_O3a={'wf' : [] , 'zebragard' : [] , 'lonetrack' : [] , 'cWB' : [] , 'XSphRad' : [] }
DATA_O3b={'wf' : [] , 'zebragard' : [] , 'lonetrack' : [] , 'cWB' : [] , 'XSphRad' : [] }
print("{:4} {:20} {:20} {:}       --- {:} {:} {:} ".format(-1,"stamp","XSphRad","cWB",0,0,0))
for i,wf in enumerate(zebragardO3a['name']):
    idx0 = i
    idx1 = np.where( wf == np.array(lonetrackO3a['name']))[0]
    idx2 = np.where( wf == np.array(cWBO3a['name']))[0]
    idx3 = np.where( dict_XSphRad[wf] == np.array(XSphRadO3a['name']))[0]
    print("{:4} {:20} {:20} {:}       --- {:} {:} {:} ".format(idx0,wf,dict_XSphRad[wf],cWBO3a['nameCWB'][idx2]
      ,idx1,idx2,idx3))
    DATA_O3a['wf'].append(wf)
    DATA_O3a['lonetrack'].append(lonetrackO3a['val'][idx1])
    DATA_O3a['zebragard'].append(zebragardO3a['val'][[i]])
    DATA_O3a['cWB'].append(cWBO3a['val'][idx2])
    DATA_O3a['XSphRad'].append(XSphRadO3a['val'][idx3])
for i,wf in enumerate(zebragardO3a['name']):
    idx0 = np.where( wf == np.array(zebragardO3b['name']))[0]
    idx1 = np.where( wf == np.array(lonetrackO3b['name']))[0]
    idx2 = np.where( wf == np.array(cWBO3b['name']))[0]
    idx3 = np.where( dict_XSphRad[wf] == np.array(XSphRadO3b['name']))[0]
    print("{:} {:20} {:20} {:}       --- {:} {:} {:} ".format(idx0,wf,dict_XSphRad[wf],cWBO3a['nameCWB'][idx2]
      ,idx1,idx2,idx3))    
    DATA_O3b['wf'].append(wf)
    DATA_O3b['lonetrack'].append(lonetrackO3b['val'][idx1])
    DATA_O3b['zebragard'].append(zebragardO3b['val'][idx0])
    DATA_O3b['cWB'].append(cWBO3b['val'][idx2])
    DATA_O3b['XSphRad'].append(XSphRadO3b['val'][idx3])
    

def SetNan(listIN):
    listOUT = []
    for i in listIN:
        if len(i) > 0 :
            listOUT.append(i[0])
        else:
            listOUT.append(np.nan)
    return listOUT

def SetNanDATA(mydata):
    for i in list(mydata):
        if i != 'wf':
            mydata[i] = SetNan(mydata[i])

SetNanDATA(DATA_O3a)
SetNanDATA(DATA_O3b)

fig, (ax,bx) = plt.subplots(1,2,figsize=(10,8))

x=np.array(range(len(DATA_O3a['wf'])))+1.0
ax.barh(x+0.5,(DATA_O3a['zebragard']),height=0.2,label='zebragard',edgecolor='k')
ax.barh(x+0.3,(DATA_O3a['lonetrack']),height=0.2,label='lonetrack',edgecolor='k')
ax.barh(x+0.1,(DATA_O3a['cWB']      ),height=0.2,label='cWB',edgecolor='k')
ax.barh(x-0.1,(DATA_O3a['XSphRad']  ),height=0.2,label='XSphRad',alpha=0.3)
ax.set_yticks(x)
ax.set_yticklabels(DATA_O3a['wf'],fontsize=8)
ax.grid()
ax.legend()
ax.set_xlim(0,3.8e-21)
ax.set_ylim(0.5,21.8)
ax.set_title('O3a')
bx.barh(x+0.5,(DATA_O3b['zebragard']),height=0.2,label='zebragard',edgecolor='k')
bx.barh(x+0.3,(DATA_O3b['lonetrack']),height=0.2,label='lonetrack',edgecolor='k')
bx.barh(x+0.1,(DATA_O3b['cWB']      ),height=0.2,label='cWB',edgecolor='k')
bx.barh(x-0.1,(DATA_O3b['XSphRad']  ),height=0.2,label='XSphRad',alpha=0.3)
bx.set_yticks(x)
bx.grid()
bx.legend()
bx.set_title('O3b')
bx.set_xlim(0,3.8e-21)
bx.set_ylim(0.5,21.8)
fig.tight_layout()
fig.savefig("LoadData.png")

  
